import 'package:fis_jsonrpc/rpc.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter_printer_plus/flutter_printer_plus.dart'
    if (dart.library.html) "package:vitalapp/pages/medical_checkup_station/usb_print/web/flutter_printer_plus.dart";
import 'package:get/get.dart';
import 'package:vitalapp/managers/interfaces/appointment.dart';
import 'package:vitalapp/managers/interfaces/registration.dart';
import 'package:vitalapp/pages/medical_checkup_station/registration/controller/form.dart';
import 'package:vitalapp/pages/medical_checkup_station/registration/controller/list.dart';
import 'package:vitalapp/pages/medical_checkup_station/registration/state/list.dart';
import 'package:vitalapp/pages/medical_checkup_station/usb_print/module/printer_info.dart';

/// 登记控制器
class RegistrationController extends GetxController {
  late final RegistrationFormController formController;
  late final RegistrationListController listController;
  final appointmentManager = Get.find<IAppointmentManager>();
  final registrationManager = Get.find<IRegistrationManager>();
  final state = ListState();

  RegistrationController() {
    listController = RegistrationListController(this);
    formController = RegistrationFormController(this);
  }

  /// 登记
  ResidentModel resident = ResidentModel(
    idNumber: '',
  );

  /// 手动填写的病人名字
  PatientDTO? patientInfo = PatientDTO();

  /// 预约列表
  List<ResidentModel> residentList = [];

  /// 预约列表的总数
  int appointmentModelListLength = 0;

  /// 表格loading
  bool tableLoading = true;

  /// 当前表格页数
  int currPageIndex = 1;
  PrinterInfo? printInfo;

//查询本地USB打印机列表
  Future<List<PrinterInfo>> queryLocalUSBPrinter() {
    return FlutterPrinterFinder.queryUsbPrinter().then(
      (value) => value.map((e) => PrinterInfo.fromUsbDevice(e)).toList(),
    );
  }

  _initData() async {
    var now = DateTime.now();
    var startTime = new DateTime(now.year, now.month, now.day);
    var endTime = startTime.add(Duration(hours: 23, minutes: 59, seconds: 59));
    await listController.getRegisterInfoPage(
        startTime: startTime, endTime: endTime);
    if (!kIsWeb) {
      List<PrinterInfo>? printerInfoList = await queryLocalUSBPrinter();
      if (printerInfoList.length == 0) {
        return;
      }
      printInfo = printerInfoList.first;
    }
  }

  void onTap() {}

  // @override
  // void onInit() {
  //   super.onInit();
  // }

  @override
  void onReady() {
    super.onReady();
    _initData();
  }

  // @override
  // void onClose() {
  //   super.onClose();
  // }
}
