import 'package:fis_theme/theme.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:get/get_state_manager/src/simple/get_view.dart';
import 'package:vitalapp/components/button.dart';
import 'package:vitalapp/components/search_input.dart';
import 'package:vitalapp/pages/medical_checkup_station/registration/controller.dart';

import 'filter_time.dart';

class RegistrationFilter extends GetView<RegistrationController> {
  const RegistrationFilter({super.key});

  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Container(
          alignment: Alignment.centerLeft,
          margin: const EdgeInsets.all(10.0), // 设置外边距
          padding: const EdgeInsets.all(5.0), // 设置内边距
          decoration: BoxDecoration(
            color: Colors.grey[200], // 设置背景颜色
            borderRadius: BorderRadius.circular(16.0), // 设置圆角边框
          ),
          height: 60,
          width: 520,
          child: VSearchInput(
            textEditingController: TextEditingController(text: ""),
            placeholder: "请输入身份证号码",
            clearable: true,
            onClear: () {},
            onSearch: (value) {
              controller.listController.getRegisterInfoPage(
                keyword: value,
              );
            },
          ),
        ),
        Expanded(child: SizedBox()),
        SizedBox(
          width: 140,
          height: 60,
          child: VButton(
            onTap: () {
              Get.dialog(FilterTime(
                onConfirm: (start, end) {
                  controller.listController.getRegisterInfoPage(
                    startTime: start,
                    endTime: end,
                  );
                },
              ));
            },
            child: Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: const [
                Icon(Icons.filter_alt, size: 24),
                Text("筛选", style: TextStyle(fontSize: 20)),
              ],
            ),
          ),
        ),
        SizedBox(
          width: 30,
        ),
      ],
    );
  }
}
